--- sendmail-8.13.3-orig/cf/m4/proto.m4	2004-08-04 17:29:55.000000000 -0400
+++ sendmail-8.13.3-mxaddr/cf/m4/proto.m4	2005-03-30 18:43:25.200778670 -0500
@@ -1029,6 +1029,14 @@
 #
 
 SParse1
+
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+#Store rcpt to host for later usage when - the mail hub feature
+R$+ <  @ $+ >			$: $(macro {ORIG_HOST} $@ $) $1 < @ $2 >
+R$+ <  @ $+ >			$: $(macro {ORIG_HOST} $@ $2 $) $1 < @ $2 >',
+`dnl')
+
+
 ifdef(`_LDAP_ROUTING_', `dnl
 # handle LDAP routing for hosts in $={LDAPRoute}
 R$+ < @ $={LDAPRoute} . >	$: $>LDAPExpand <$1 < @ $2 . >> <$1 @ $2> <>
@@ -1257,11 +1265,21 @@
 ifdef(`_PRESERVE_LUSER_HOST_', `dnl
 dnl it is $~[ instead of $- to avoid matches on IPv6 addresses
 R< $~[ : $+ > $+ @ $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $4 >')
-R< $~[ : $+ > $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $2 >
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+R< $~[ : $+ > $+ @ $+	$: < $1 [ : $2 > $3 < @ $&{ORIG_HOST} >
+R< $~[ : $+ > $+ < @ >	$: < $1 [ : $2 > $3
+R< $~[ : $+ > $+ < @ $+ >	$@ $>MailerToTriple < $1 : $2 > $3 < @ $&{ORIG_HOST} >
+R< $~[ : $+ > $+ 	$@ $>MailerToTriple < $1 : $2 > $3 < @ $&{ORIG_HOST} >
+dnl',`dnl
+R< $~[ : $+ > $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $2 >')
 ifdef(`_PRESERVE_LUSER_HOST_', `dnl
 R< $+ > $+ @ $+		$@ $>MailerToTriple < $1 > $2 < @ $3 >')
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+R< $+ > $+		$: < $1 > $2 < @ $&{ORIG_HOST} >
+R< $+ > $+ < @ >	$: < $1 > $2
+R< $+ > $+ < @ $+ >	$@ $>MailerToTriple < $1 > $2 < @ $3 >
+dnl',`dnl')
 R< $+ > $+		$@ $>MailerToTriple < $1 > $2 < @ $1 >
-
 ifdef(`_MAILER_TABLE_', `dnl
 ifdef(`_LDAP_ROUTING_', `dnl
 ###################################################################
